# Getting Started with Artifician

Welcome to the world of simplified data preparation with Artifician. To ensure a smooth experience, please follow this installation guide.

## Pre-requisites

Before you can install Artifician, make sure your system meets the following prerequisites:

- Python 3.6 or higher: Artifician is built on Python. If you haven’t installed Python yet, you can download it from [here](https://www.python.org/downloads/).

To check your Python version, run the following command in your terminal:

```bash
python --version
```

or

```bash
python3 --version
```

## Installation

Artifician can be easily installed through either pip or conda. Choose the method that’s most compatible with your workflow.

## Using pip

If you are using pip, you can install Artifician with the following command:

```bash
pip install artifician
```

## Using conda

For conda users, the package is available through the Plato Solutions channel. Install it using:

```bash
conda install -c plato-solutions artifician
```

## Verify Installation

To verify that Artifician has been installed successfully, run the following command:

```bash
python -c "import artifician; print(artifician.__version__)"
```

If this prints the version number, congratulations! You’ve successfully installed Artifician and are ready to revolutionize your data preparation process.

## Next Steps

Now that you’ve installed Artifician, it’s time to dive in and start using it. Head over to our [Quick Start](quick_start.rst) to learn more about how you can leverage Artifician to simplify your dataset preparation.
